<script setup>
//import { date } from 'alga-js'
import { toast } from 'bulma-toast'

const router = useRouter()
const activeSave = useActiveSave()

definePageMeta({
  middleware: ['auth', 'org']
})

//const clients = useCookie('logship_clients')
const client = useCookie('logship_client')
const clientId = useCookie('logship_client_id')
//const organizations = useCookie('logship_organizations')
const organization = useCookie('logship_organization')
const organizationId = useCookie('logship_organization_id')

const form = ref({
  id: '',
  uid: '',
  client: client.value?.Name || '',
  clientId: clientId.value || '',
  organization: organization.value?.Name || '',
  organizationId: organizationId.value || '',
  isActive: true,
  documentNo: '',
  description: '',
  isApproved: false,
  name: '',
  processing: true,
  isSOTrx: false,
  processed: false,
  amt: 0,
  help: '',
  inOut: '',
  inOutId: '',
  order: '',
  orderId: '',
  docType: '',
  docTypeId: '',
  docStatus: 'Draft',
  docStatusId: 'DR',
  salesRep: '',
  salesRepId: '',
  rmaType: '',
  rmaTypeId: '',
  currency: '',
  currencyId: '',
  partner: '',
  partnerId: '',
  processing: false,
  alert: {
    status: '',
    message: '',
    processing: false,
  }
})

const back = () => {
  if(activeSave.value) {
    toast({
      message: 'Save button is active, please submit the data before leaving!',
      type: 'is-warning',
      duration: 2000
    })
  } else {
    router.push('/procurements/vendor-rma')
  }
}

const save = async (record) => {
  form.value = record

  if(form.value.name !== '' && form.value.docTypeId !== '' && form.value.inOutId !== '' && form.value.salesRepId !== '' && form.value.rmaTypeId !== '') {
    activeSave.value = true
  } else {
    activeSave.value = false
  }
}

const submit = async (saveType = '') => {
  form.value.alert.processing = true
  activeSave.value = true

  const res = await $fetch('/api/rma/store', {
    method: 'POST',
    headers: useRequestHeaders(['cookie']),
    body: {
      organizationId: form.value.organizationId,
      isActive: form.value.isActive,
      documentNo: form.value.documentNo,
      description: form.value.description,
      isApproved: form.value.isApproved,
      name: form.value.name,
      processing: form.value.processing,
      isSOTrx: false,
      processed: form.value.processed,
      amt: form.value.amt,
      help: form.value.help,
      inOutId: form.value.inOutId,
      orderId: form.value.orderId,
      docTypeId: form.value.docTypeId,
      docStatusId: form.value.docStatusId,
      salesRepId: form.value.salesRepId,
      rmaTypeId: form.value.rmaTypeId,
      currencyId: form.value.currencyId,
      partnerId: form.value.partnerId,
    }
  })

  if(Number(res.status) === 200) {
    form.value.alert.processing = false
    activeSave.value = false

    if(saveType === 'preview') {
      router.push('/procurements/vendor-rma/'+res.id+'/view')
    } else if(saveType === 'changes' || saveType === 'onlysave') {
      router.push('/procurements/vendor-rma/'+res.id+'/edit')
      toast({
        message: 'Saved!',
        type: 'is-success',
        duration: 2000
      })
    } else {
      back()
    }
  } else {
    //form.value.alert.status = res.status
    //form.value.alert.message = res.message
    form.value.alert.processing = false
    activeSave.value = false
    toast({
      message: res.message || 'Save error',
      type: 'is-danger',
      duration: 2000
    })
    //window.scrollTo(0, 0)
  }
}

const breadCrumb = computed(() => ([
  { link: '#', text: 'Procurements'},
  { link: '/procurements/vendor-rma', text: 'Vendor RMA'},
  { link: '#', text: 'Add RMA', active: true}
]))
</script>

<template>
  <Head>
    <Title>Add RMA</Title>
  </Head>

  <NuxtLayout name="new-dash">
    <NewBreadCrumb :items="breadCrumb" />
    
    <div class="bannercontrol">
      <div class="d-flex gap-10px">
        <button type="button" @click="submit('onlysave')" class="button" :class="(form.name === '' || form.docTypeId === '' || form.inOutId === '' || form.salesRepId === '' || form.rmaTypeId === '' || form.docStatusId === 'CO' || form.alert.processing) ? 'pointerEvents-none opacity-0.6' : ''">Save</button>
      </div>
      <div>
        <div class="d-flex gap-10px">
          <button v-if="activeSave" type="button" @click="activeSave = false; back();" class="button">
            <span class="tf-icon ti ti-square-x ti-xs me-1 color-inherit"></span> Abort
          </button>
          <button type="button" @click="back" class="button">
            <span class="tf-icon ti ti-chevron-left ti-xs me-1 color-inherit"></span> Back
          </button>
        </div>
      </div>
    </div>
    
    <div class="banner">
      <div>
        <RmasVendorRmaForm v-model="form" @save="save" />
      </div>
      <div class="opacity-0.6 pointerEvents-none">
        <RmasVendorRmaDetailRecord action="create" :info="form" />
      </div>
    </div>
  </NuxtLayout>
</template>